import pygame
import time, sys, os
import OSC
from OSC import OSCServer
from time import sleep
import RPi.GPIO as GPIO

server = OSCServer( ("192.168.1.13", 44113) )
server.timeout = 0
run = True
pygame.mixer.init()
pygame.mixer.pre_init(44100, -16, 2, 256)
pygame.init()

pygame.display.set_mode((320, 200))

# --------------------definition des GPIO
GPIO.setmode(GPIO.BCM)
GPIO.setup(17, GPIO.IN)


oscvalprevious = '0'
oscval = '0'
oscsendmessage = 0
shutdowna = '0'

def handle_timeout(self):
    self.timed_out = True

import types
server.handle_timeout = types.MethodType(handle_timeout, server)

def user_callback(path, tags, args, source):
    global oscval 
    oscval = str (args[0])

server.addMsgHandler( "z1", user_callback )


def noteplayerc1 (path, fade):
    global oscvalprevious
    global oscsendmessage
    global oscval

    	
    if oscval != '0' and oscval <= '120':
            soundfileID = oscval
            if soundfileID != oscvalprevious :
                soundfile = path + 'archives_audio_' + oscval + '.wav' 
                pygame.mixer.music.load(soundfile)
                pygame.mixer.music.set_volume(2)
                pygame.mixer.music.play()                                                            
                print (soundfile)
                if pygame.mixer.music.get_busy() == True:
                    oscvalprevious = oscval
                    oscsendmessage = 1
                    return oscsendmessage
                    
    if oscval == '0':
			oscsendmessage = 0
			oscval = '0'
			oscvalprevious = '0'
							

def each_frame():
    # clear timed_out flag
    server.timed_out = False
    # handle all pending requests then return
    while not server.timed_out:
        server.handle_request()

def shutdown():
	global oscval, shutdowna
	if GPIO.input(17) == False:	
		oscval = '666'
		shutdowna = '666'
		print ('shutdown')
		
	

#c5 = pygame.mixer.Channel(4)  
#c5.play(pygame.mixer.Sound('/home/pi/archives1418/sound/ultrason.aif'), -1)

mainloop = True


while mainloop:
#    	sleep(0.1)
    	each_frame()


    	noteplayerc1 ("/home/pi/archives1418/sound/", 100)
    	shutdown()
    	
    	client = OSC.OSCClient()
    	client.connect(('192.168.1.10', 44011))
    	msg = OSC.OSCMessage()
    	msg.setAddress('/z1')
    	msg.append(oscsendmessage)
    	client.send(msg)
    	
    	clientz1625 = OSC.OSCClient()
    	clientz1625.connect(('192.168.1.10', 44110))    	
    	msgz1625 = OSC.OSCMessage()
    	msgz1625.setAddress('/shutdown')
    	msgz1625.append(shutdowna)
    	clientz1625.send(msgz1625)
 
     	clientz34 = OSC.OSCClient()
    	clientz34.connect(('192.168.1.09', 44109))    	
    	clientz34.send(msgz1625)
	
    	clientz1 = OSC.OSCClient()
    	clientz1.connect(('192.168.1.11', 44111))    	
    	msgz1 = OSC.OSCMessage()
    	msgz1.setAddress('/z1')
    	msgz1.append(shutdowna)
    	clientz1.send(msgz1)
    	
    	clientz2 = OSC.OSCClient()
    	clientz2.connect(('192.168.1.12', 44112))    	
    	msgz2 = OSC.OSCMessage()
    	msgz2.setAddress('/z2')
    	msgz2.append(shutdowna)
    	clientz2.send(msgz2)
    	
    	clientz3 = OSC.OSCClient()
    	clientz3.connect(('192.168.1.13', 44113))    	
    	msgz3 = OSC.OSCMessage()
    	msgz3.setAddress('/z3')
    	msgz3.append(shutdowna)
    	clientz3.send(msgz3)
    	
    	clientz4 = OSC.OSCClient()
    	clientz4.connect(('192.168.1.14', 44114))    	
    	msgz4 = OSC.OSCMessage()
    	msgz4.setAddress('/z4')
    	msgz4.append(shutdowna)
    	clientz4.send(msgz4)
    	
    	clientz5 = OSC.OSCClient()
    	clientz5.connect(('192.168.1.15', 44115))    	
    	msgz5 = OSC.OSCMessage()
    	msgz5.setAddress('/z5')
    	msgz5.append(shutdowna)
    	clientz5.send(msgz5)
    	
    	clientz6 = OSC.OSCClient()
    	clientz6.connect(('192.168.1.16', 44116))    	
    	msgz6 = OSC.OSCMessage()
    	msgz6.setAddress('/z6')
    	msgz6.append(shutdowna)
    	clientz6.send(msgz6)
    	
    	if oscval == '666':
				pygame.display.flip()
				time.sleep(1)
				#os.system("sudo shutdown -h now")
				pygame.quit()
				sys.exit()   
			
    	
    	for event in pygame.event.get():
    		if event.type == pygame.KEYDOWN:
                            if event.key == pygame.K_ESCAPE:
                                pygame.mixer.fadeout(3000)
                                pygame.display.flip()
                                #time.sleep(1)
                                pygame.quit()
                                sys.exit()                                

#    	print (val)
    	 	

server.close()                               
