import pygame
import time, sys, os
import OSC
from OSC import OSCServer
from time import sleep

server = OSCServer( ("192.168.1.11", 44111) )
server.timeout = 0
run = True
pygame.mixer.init()
pygame.mixer.pre_init(44100, -16, 2, 256)
pygame.init()

pygame.display.set_mode((320, 200))


oscvalprevious = '0'
oscval = '0'
oscsendmessage = 0

def handle_timeout(self):
    self.timed_out = True

import types
server.handle_timeout = types.MethodType(handle_timeout, server)

def user_callback(path, tags, args, source):
    global oscval 
    oscval = str (args[0])

server.addMsgHandler( "z1", user_callback )


def noteplayerc1 (path, fade):
    global oscvalprevious
    global oscsendmessage
    global oscval

    	
    if oscval != '0' and oscval <= '120':
            soundfileID = oscval
            if soundfileID != oscvalprevious :
                soundfile = path + 'archives_audio_' + oscval + '.wav' 
                pygame.mixer.music.load(soundfile)
                pygame.mixer.music.set_volume(2)
                pygame.mixer.music.play()                                                            
                print (soundfile)
                if pygame.mixer.music.get_busy() == True:
                    oscvalprevious = oscval
                    oscsendmessage = 1
                    return oscsendmessage
    if oscval == '0':
    			oscsendmessage = 0
    			oscval = '0'
    			oscvalprevious = '0'
			
    if oscval == 'shutdown':
                pygame.display.flip()
                #time.sleep(1)
                os.system("sudo shutdown -h now")
                pygame.quit()
                sys.exit()   	                	
		server.close() 
				

def each_frame():
    # clear timed_out flag
    server.timed_out = False
    # handle all pending requests then return
    while not server.timed_out:
        server.handle_request()

#c5 = pygame.mixer.Channel(4)  
#c5.play(pygame.mixer.Sound('/home/pi/archives1418/sound/ultrason.aif'), -1)

mainloop = True


while mainloop:
#    	sleep(0.1)
    	each_frame()


    	noteplayerc1 ("/home/pi/archives1418/sound/", 100)
    	client = OSC.OSCClient()
    	client.connect(('192.168.1.10', 44011))
    	msg = OSC.OSCMessage()
    	msg.setAddress('/z1')
    	msg.append(oscsendmessage)
    	client.send(msg)
    	
    	if oscval == '666':
				pygame.display.flip()
				time.sleep(1)
				os.system("sudo shutdown -h now")
				pygame.quit()
				sys.exit()   	
    	
    	for event in pygame.event.get():
    		if event.type == pygame.KEYDOWN:
                            if event.key == pygame.K_ESCAPE:
                                pygame.mixer.fadeout(3000)
                                pygame.display.flip()
                                #time.sleep(1)
                                pygame.quit()
                                sys.exit()                                

#    	print (val)
    	 	

server.close()                               
